/*
 * fmgrrtrv: FileManager.  Retrives the linked list of ints saved by fmgrsave.
 * This example appears in Section 11.2 of the manual.
 *
 * $Id: fmgrrtrv.cpp,v 7.9 1995/09/06 23:44:02 jims Exp $
 *
 * (c) Copyright 1989 - 1996 Rogue Wave Software, Inc.
 * ALL RIGHTS RESERVED
 *
 * The software and information contained herein are proprietary to, and
 * comprise valuable trade secrets of, Rogue Wave Software, Inc., which
 * intends to preserve as trade secrets such software and information.
 * This software is furnished pursuant to a written license agreement and
 * may be used, copied, transmitted, and stored only in accordance with
 * the terms of such license and with the inclusion of the above copyright
 * notice.  This software and information or any other copies thereof may
 * not be provided or otherwise made available to any other person.
 *
 * Notwithstanding any other lease or license that may pertain to, or
 * accompany the delivery of, this computer software and information, the
 * rights of the Government regarding its use, reproduction and disclosure
 * are as set forth in Section 52.227-19 of the FARS Computer
 * Software-Restricted Rights clause.
 * 
 * Use, duplication, or disclosure by the Government is subject to
 * restrictions as set forth in subparagraph (c)(1)(ii) of the Rights in
 * Technical Data and Computer Software clause at DFARS 252.227-7013.
 * Contractor/Manufacturer is Rogue Wave Software, Inc.,
 * P.O. Box 2328, Corvallis, Oregon 97339.
 *
 * This computer software and information is distributed with "restricted
 * rights."  Use, duplication or disclosure is subject to restrictions as
 * set forth in NASA FAR SUP 18-52.227-79 (April 1985) "Commercial
 * Computer Software-Restricted Rights (April 1985)."  If the Clause at
 * 18-52.227-74 "Rights in Data General" is specified in the contract,
 * then the "Alternate III" clause applies.
 *
 ***************************************************************************
 *
 * $Log: fmgrrtrv.cpp,v $
 * Revision 7.9  1995/09/06 23:44:02  jims
 * Use new copyright macro
 *
 * Revision 7.8  1995/08/25  16:12:01  pearson
 * Corrected test for no file
 *
 * Revision 7.7  1995/07/13  23:10:51  pearson
 * Corrected name of program in error message.
 *
 * Revision 7.6  1995/07/13  16:01:01  pearson
 * Update of example file names
 *
 * Revision 7.5  1995/07/11  21:28:36  pearson
 * Added return 0 for all control paths.
 *
 * Revision 7.4  1995/07/05  17:31:07  pearson
 * (#728) Changed the test if(fm.IsEmpty()) to if(!fm.Exists()).
 *
 * Revision 7.3  1995/06/28  14:31:06  pearson
 * *** empty log message ***
 *
 * Revision 7.2  95/06/26  15:36:00  15:36:00  pearson (Thomas Pearson)
 * (#728) Added error checking for instance when no data file has been
 * created using fmgrsave.      Tom P.
 * 
 * Revision 7.1  94/10/16  04:14:45  04:14:45  josh
 * Merged 6.1 and 7.0 development trees
 * 
 * Revision 6.3  1994/07/12  20:40:30  vriezen
 * Updated Copyright
 *
 * Revision 6.2  1994/06/02  20:41:30  foote
 * Port to Symantec 7.0 on Macintosh
 *
 * Revision 6.1  1994/04/15  19:08:32  vriezen
 * Move all files to 6.1
 *
 * Revision 2.1  1992/12/04  05:07:27  myersn
 * update for tools.h++ 6.0
 *
 * Revision 2.0  1992/10/23  03:34:26  keffer
 * RCS Baseline version
 *
 * 
 *    Rev 1.1   07 Jun 1992 17:11:10   KEFFER
 * Tools.h++ V5.1
 * 
 */

#include "rw/filemgr.h"
#include "rw/rstream.h"

struct DiskNode {
  int      data;
  RWoffset nextNode;
};

main()
{
 
  RWFileManager fm("linklist.dat");

  // The constructor for RWFileManager will create a file if it does not
  // already exist.  "IsEmpty()" is used to prevent errors caused by trying 
  // to read the linked list file before it is created.

  if(fm.start() == RWNIL)
     cerr << "You must create a linked list file using fmgrsave.exe\n"
          << "before you run this program.\n\n ";
  else
  {  
     fm.SeekTo(fm.start());
     RWoffset next;
     fm.Read(next);
  
     DiskNode n;
     while (next != RWNIL) {
       fm.SeekTo(next);
       fm.Read(n.data);
       fm.Read(n.nextNode);
       cout << n.data << "\n";
       next = n.nextNode;
     }
     cout.flush();
  }
 return 0;
}

