/*
 * This example is from the Tools.h++ manual, version 7
 *
 * (c) Copyright 1989 - 1996 Rogue Wave Software, Inc.
 * ALL RIGHTS RESERVED
 *
 * The software and information contained herein are proprietary to, and
 * comprise valuable trade secrets of, Rogue Wave Software, Inc., which
 * intends to preserve as trade secrets such software and information.
 * This software is furnished pursuant to a written license agreement and
 * may be used, copied, transmitted, and stored only in accordance with
 * the terms of such license and with the inclusion of the above copyright
 * notice.  This software and information or any other copies thereof may
 * not be provided or otherwise made available to any other person.
 *
 * Notwithstanding any other lease or license that may pertain to, or
 * accompany the delivery of, this computer software and information, the
 * rights of the Government regarding its use, reproduction and disclosure
 * are as set forth in Section 52.227-19 of the FARS Computer
 * Software-Restricted Rights clause.
 * 
 * Use, duplication, or disclosure by the Government is subject to
 * restrictions as set forth in subparagraph (c)(1)(ii) of the Rights in
 * Technical Data and Computer Software clause at DFARS 252.227-7013.
 * Contractor/Manufacturer is Rogue Wave Software, Inc.,
 * P.O. Box 2328, Corvallis, Oregon 97339.
 *
 * This computer software and information is distributed with "restricted
 * rights."  Use, duplication or disclosure is subject to restrictions as
 * set forth in NASA FAR SUP 18-52.227-79 (April 1985) "Commercial
 * Computer Software-Restricted Rights (April 1985)."  If the Clause at
 * 18-52.227-74 "Rights in Data General" is specified in the contract,
 * then the "Alternate III" clause applies.
 */
#include <rw/collstr.h>

#include <rw/disktree.h>
#include <rw/filemgr.h>

main()
{
   RWBTreeOnDisk *btrees[3];

   RWoffset rootArray[3];         //Stores offsets to the RWBTreeOnDisks 
                                  //within the managed file "fm"
   RWoffset recordloc;

   const RWCollectableString crossreference[5][3] =
        {  "Rogue Wave Software", "Corvallis",     "(503) 754-3010",
           "Microsoft",           "Redmond",       "(206) 882-8080",
           "Borland",             "Scotts Valley", "(408) 431-1000",
           "Symantec",            "Long Beach",    "(310) 449-4140",
           "SGI",                 "San Ramon",     "(619) 371-7760"  };


   RWFileManager fm("index.dat");
   RWoffset rootArrayOffset = fm.allocate(sizeof(rootArray));

   for (int itree=0; itree<3; itree++)
   {
     btrees[itree] = new RWBTreeOnDisk(fm, 10, RWBTreeOnDisk::create);
     rootArray[itree] = btrees[itree] -> baseLocation();
   }

   fm.SeekTo(rootArrayOffset);

   fm.Write(rootArray, 3);

   for(int recnum=0; recnum < 5; recnum++)
   {
     recordloc = fm.allocate( crossreference[recnum][0].recursiveStoreSize() +
                              crossreference[recnum][1].recursiveStoreSize() +
                              crossreference[recnum][2].recursiveStoreSize() );
     fm.SeekTo(recordloc);
     fm << crossreference[recnum][0]; 
     fm << crossreference[recnum][1]; 
     fm << crossreference[recnum][2]; 

     btrees[0] -> insertKeyAndValue(crossreference[recnum][0],recordloc);
     btrees[1] -> insertKeyAndValue(crossreference[recnum][1],recordloc);
     btrees[2] -> insertKeyAndValue(crossreference[recnum][2],recordloc);
     
   }

   delete[] btrees;
   return 0;
}
