/*
 * This example is from the Tools.h++ manual, version 7
 *
 * (c) Copyright 1989 - 1996 Rogue Wave Software, Inc.
 * ALL RIGHTS RESERVED
 *
 * The software and information contained herein are proprietary to, and
 * comprise valuable trade secrets of, Rogue Wave Software, Inc., which
 * intends to preserve as trade secrets such software and information.
 * This software is furnished pursuant to a written license agreement and
 * may be used, copied, transmitted, and stored only in accordance with
 * the terms of such license and with the inclusion of the above copyright
 * notice.  This software and information or any other copies thereof may
 * not be provided or otherwise made available to any other person.
 *
 * Notwithstanding any other lease or license that may pertain to, or
 * accompany the delivery of, this computer software and information, the
 * rights of the Government regarding its use, reproduction and disclosure
 * are as set forth in Section 52.227-19 of the FARS Computer
 * Software-Restricted Rights clause.
 * 
 * Use, duplication, or disclosure by the Government is subject to
 * restrictions as set forth in subparagraph (c)(1)(ii) of the Rights in
 * Technical Data and Computer Software clause at DFARS 252.227-7013.
 * Contractor/Manufacturer is Rogue Wave Software, Inc.,
 * P.O. Box 2328, Corvallis, Oregon 97339.
 *
 * This computer software and information is distributed with "restricted
 * rights."  Use, duplication or disclosure is subject to restrictions as
 * set forth in NASA FAR SUP 18-52.227-79 (April 1985) "Commercial
 * Computer Software-Restricted Rights (April 1985)."  If the Clause at
 * 18-52.227-74 "Rights in Data General" is specified in the contract,
 * then the "Alternate III" clause applies.
 */
#include <rw/cstring.h>
#include <iostream.h>

RWCString g;	// Global object

void setGlobal(RWCString x) { g = x; }

main(){
  RWCString a("kernel");	// 1
  RWCString b(a);	// 2
  RWCString c(a);	// 3

  setGlobal(a);	// Still only one copy of "kernel"!	// 4

  cout << "Before copy on write: " << endl;
  cout << "Strings:\t" << a << "\t" << b << "\t"
                       << c << "\t" << g << endl ;

  cout << "Addresses:\t" << (void *)a.data() << "\t"
                         << (void *)b.data() << "\t"
                         << (void *)c.data() << "\t"
                         << (void *)g.data() << endl;

  b += "s";	// Now b has its own data: "kernels"	// 5

  cout << endl << "After copy on write: " << endl;
  cout << "Strings:\t" << a << "\t" << b << "\t"
                       << c << "\t" << g << endl ;

  cout << "Addresses:\t" << (void *)a.data() << "\t"
                         << (void *)b.data() << "\t"
                         << (void *)c.data() << "\t"
                         << (void *)g.data() << endl;

  return 0;
}
