/*
 * This example is from the Tools.h++ manual, version 7
 *
 * (c) Copyright 1989 - 1996 Rogue Wave Software, Inc.
 * ALL RIGHTS RESERVED
 *
 * The software and information contained herein are proprietary to, and
 * comprise valuable trade secrets of, Rogue Wave Software, Inc., which
 * intends to preserve as trade secrets such software and information.
 * This software is furnished pursuant to a written license agreement and
 * may be used, copied, transmitted, and stored only in accordance with
 * the terms of such license and with the inclusion of the above copyright
 * notice.  This software and information or any other copies thereof may
 * not be provided or otherwise made available to any other person.
 *
 * Notwithstanding any other lease or license that may pertain to, or
 * accompany the delivery of, this computer software and information, the
 * rights of the Government regarding its use, reproduction and disclosure
 * are as set forth in Section 52.227-19 of the FARS Computer
 * Software-Restricted Rights clause.
 * 
 * Use, duplication, or disclosure by the Government is subject to
 * restrictions as set forth in subparagraph (c)(1)(ii) of the Rights in
 * Technical Data and Computer Software clause at DFARS 252.227-7013.
 * Contractor/Manufacturer is Rogue Wave Software, Inc.,
 * P.O. Box 2328, Corvallis, Oregon 97339.
 *
 * This computer software and information is distributed with "restricted
 * rights."  Use, duplication or disclosure is subject to restrictions as
 * set forth in NASA FAR SUP 18-52.227-79 (April 1985) "Commercial
 * Computer Software-Restricted Rights (April 1985)."  If the Clause at
 * 18-52.227-74 "Rights in Data General" is specified in the contract,
 * then the "Alternate III" clause applies.
 */
#include <rw/gsortvec.h>
#include <rw/rstream.h>
#include <iostream.h>

declare(RWGVector,int)
declare(RWGSortedVector,int)
implement(RWGVector,int)
implement(RWGSortedVector,int)

// Declare and define "comparison function" to partition even and odd numbers
int compFun(const int* a, const int* b)  {
      return (*a%2) - (*b%2);
}

main()  {
  // Declare and define an instance,
  // using the comparison function 'compFun':
  RWGSortedVector(int) avec(compFun);

  int someData[6] = {3, 17, 4, 5, 32, -1};

  cout << "When these numbers are inserted as follows:"
       << endl << "\t";


  // Do some insertions:
  int i = 0;
  while(someData[i] > 0)
  {
     avec.insert(someData[i]);
     cout << someData[i++] << "\t";
  }
 

  cout << endl << endl << "Now the RWGSortedVector is ordered as follows: "
       << endl << "\t";

  for(i = 0; i < avec.entries(); i++)
     cout << avec(i) << "\t";


  cout << endl << endl
       << "The second element is: " << avec(1);   

  cout << endl 
       << "The index of the first odd element is: " << avec.index(1)
       << endl; 

  return 0;
}
