/*
 * This example is from the Tools.h++ manual, version 7
 *
 * (c) Copyright 1989 - 1996 Rogue Wave Software, Inc.
 * ALL RIGHTS RESERVED
 *
 * The software and information contained herein are proprietary to, and
 * comprise valuable trade secrets of, Rogue Wave Software, Inc., which
 * intends to preserve as trade secrets such software and information.
 * This software is furnished pursuant to a written license agreement and
 * may be used, copied, transmitted, and stored only in accordance with
 * the terms of such license and with the inclusion of the above copyright
 * notice.  This software and information or any other copies thereof may
 * not be provided or otherwise made available to any other person.
 *
 * Notwithstanding any other lease or license that may pertain to, or
 * accompany the delivery of, this computer software and information, the
 * rights of the Government regarding its use, reproduction and disclosure
 * are as set forth in Section 52.227-19 of the FARS Computer
 * Software-Restricted Rights clause.
 * 
 * Use, duplication, or disclosure by the Government is subject to
 * restrictions as set forth in subparagraph (c)(1)(ii) of the Rights in
 * Technical Data and Computer Software clause at DFARS 252.227-7013.
 * Contractor/Manufacturer is Rogue Wave Software, Inc.,
 * P.O. Box 2328, Corvallis, Oregon 97339.
 *
 * This computer software and information is distributed with "restricted
 * rights."  Use, duplication or disclosure is subject to restrictions as
 * set forth in NASA FAR SUP 18-52.227-79 (April 1985) "Commercial
 * Computer Software-Restricted Rights (April 1985)."  If the Clause at
 * 18-52.227-74 "Rights in Data General" is specified in the contract,
 * then the "Alternate III" clause applies.
 */
#include <rw/model.h>

class Dial : public RWModelClient
{
     int dialNumber;

  public:

     Dial(int dialNumber);
     virtual void updateFrom(RWModel* m, void* d);

};


class Thermostat : public RWModel
{
    double setting;

  public:

    Thermostat( Dial* d )
      { addDependent(d); setting = 0; }

    double temperature() const
      { return setting; }

    void setTemperature(double t)
      { setting = t; changed(); }
};


void Dial::updateFrom(RWModel* m, void*)
{
  Thermostat* t = (Thermostat*)m;
  double temp = t -> temperature();

  // Redraw graphic.
  cout << "Dial #" << dialNumber
       << " says " << temp << endl;
}


Dial::Dial(int num) : dialNumber(num)
{;}


main()
{
   Dial one(1);
   Dial two(2);

   Thermostat therm(&one);

   therm.setTemperature(77);
   therm.setTemperature(-4);

   therm.addDependent(&two);

   therm.setTemperature(47); 

   return 0;
}
