/*
 * This example is from the Tools.h++ manual, version 7
 *
 * (c) Copyright 1989 - 1996 Rogue Wave Software, Inc.
 * ALL RIGHTS RESERVED
 *
 * The software and information contained herein are proprietary to, and
 * comprise valuable trade secrets of, Rogue Wave Software, Inc., which
 * intends to preserve as trade secrets such software and information.
 * This software is furnished pursuant to a written license agreement and
 * may be used, copied, transmitted, and stored only in accordance with
 * the terms of such license and with the inclusion of the above copyright
 * notice.  This software and information or any other copies thereof may
 * not be provided or otherwise made available to any other person.
 *
 * Notwithstanding any other lease or license that may pertain to, or
 * accompany the delivery of, this computer software and information, the
 * rights of the Government regarding its use, reproduction and disclosure
 * are as set forth in Section 52.227-19 of the FARS Computer
 * Software-Restricted Rights clause.
 * 
 * Use, duplication, or disclosure by the Government is subject to
 * restrictions as set forth in subparagraph (c)(1)(ii) of the Rights in
 * Technical Data and Computer Software clause at DFARS 252.227-7013.
 * Contractor/Manufacturer is Rogue Wave Software, Inc.,
 * P.O. Box 2328, Corvallis, Oregon 97339.
 *
 * This computer software and information is distributed with "restricted
 * rights."  Use, duplication or disclosure is subject to restrictions as
 * set forth in NASA FAR SUP 18-52.227-79 (April 1985) "Commercial
 * Computer Software-Restricted Rights (April 1985)."  If the Clause at
 * 18-52.227-74 "Rights in Data General" is specified in the contract,
 * then the "Alternate III" clause applies.
 */
//Instructions:  Pipe the output from save1 into this program, as in ->
//               save1 | read1

#define RW_STD_TYPEDEFS
#include <rw/bintree.h>
#include <rw/collstr.h>
#include <rw/pstream.h>

main(){
   RWpistream istr(cin);
   SortedCollection sc2;

   // Read the collection back in:
   istr >> sc2;	// 4

   RWCollectableString temp("George");	// 5

   // Find a "George":
   RWCollectableString* g = (RWCollectableString*)(sc2.find(&temp));	// 6

   // "g" now points to a string with the value "George"
   // How many occurrences of g are there in the 	collection?

   unsigned count = 0;	// 7
   SortedCollectionIterator sci(sc2);	// 8
   RWCollectableString* item;
   cout << "Strings in the collection are: " << endl;

   while ( item = (RWCollectableString*)sci() )   // 9
   {
     if(item)
       cout << "\t" << *item << endl; 

     if ( item==g )	//10
       count++;
   }

   cout << endl << "There are " << count << "  " << temp << "'s" << endl;

   sc2.clearAndDestroy();	//11

   return 0;
}
