/*
 * This example is from the Tools.h++ manual, version 7
 *
 * (c) Copyright 1989 - 1996 Rogue Wave Software, Inc.
 * ALL RIGHTS RESERVED
 *
 * The software and information contained herein are proprietary to, and
 * comprise valuable trade secrets of, Rogue Wave Software, Inc., which
 * intends to preserve as trade secrets such software and information.
 * This software is furnished pursuant to a written license agreement and
 * may be used, copied, transmitted, and stored only in accordance with
 * the terms of such license and with the inclusion of the above copyright
 * notice.  This software and information or any other copies thereof may
 * not be provided or otherwise made available to any other person.
 *
 * Notwithstanding any other lease or license that may pertain to, or
 * accompany the delivery of, this computer software and information, the
 * rights of the Government regarding its use, reproduction and disclosure
 * are as set forth in Section 52.227-19 of the FARS Computer
 * Software-Restricted Rights clause.
 * 
 * Use, duplication, or disclosure by the Government is subject to
 * restrictions as set forth in subparagraph (c)(1)(ii) of the Rights in
 * Technical Data and Computer Software clause at DFARS 252.227-7013.
 * Contractor/Manufacturer is Rogue Wave Software, Inc.,
 * P.O. Box 2328, Corvallis, Oregon 97339.
 *
 * This computer software and information is distributed with "restricted
 * rights."  Use, duplication or disclosure is subject to restrictions as
 * set forth in NASA FAR SUP 18-52.227-79 (April 1985) "Commercial
 * Computer Software-Restricted Rights (April 1985)."  If the Clause at
 * 18-52.227-74 "Rights in Data General" is specified in the contract,
 * then the "Alternate III" clause applies.
 */
#define RW_STD_TYPEDEFS 1	// 1
#include <rw/bintree.h>
#include <rw/collstr.h>	// 2
#include <rw/rstream.h>

main(){
	// Construct an empty SortedCollection
	SortedCollection sc;	// 3

	// Insert some RWCollectableStrings:
	sc.insert(new RWCollectableString("George"));	// 4
	sc.insert(new RWCollectableString("Mary"));	// 5
	sc.insert(new RWCollectableString("Bill"));	// 6
	sc.insert(new RWCollectableString("Throkmorton"));	// 7

	// Now iterate through the collection,
	// printing all members:
	RWCollectableString* str;	//  8

	SortedCollectionIterator sci(sc);	//  9
	while( str = (RWCollectableString*)sci() )	// 10
		cout << *str << endl;	// 11

	sc.clearAndDestroy();
	return 0;
}
