/*
 * This example is from the Tools.h++ manual, version 7
 *
 * (c) Copyright 1989 - 1996 Rogue Wave Software, Inc.
 * ALL RIGHTS RESERVED
 *
 * The software and information contained herein are proprietary to, and
 * comprise valuable trade secrets of, Rogue Wave Software, Inc., which
 * intends to preserve as trade secrets such software and information.
 * This software is furnished pursuant to a written license agreement and
 * may be used, copied, transmitted, and stored only in accordance with
 * the terms of such license and with the inclusion of the above copyright
 * notice.  This software and information or any other copies thereof may
 * not be provided or otherwise made available to any other person.
 *
 * Notwithstanding any other lease or license that may pertain to, or
 * accompany the delivery of, this computer software and information, the
 * rights of the Government regarding its use, reproduction and disclosure
 * are as set forth in Section 52.227-19 of the FARS Computer
 * Software-Restricted Rights clause.
 * 
 * Use, duplication, or disclosure by the Government is subject to
 * restrictions as set forth in subparagraph (c)(1)(ii) of the Rights in
 * Technical Data and Computer Software clause at DFARS 252.227-7013.
 * Contractor/Manufacturer is Rogue Wave Software, Inc.,
 * P.O. Box 2328, Corvallis, Oregon 97339.
 *
 * This computer software and information is distributed with "restricted
 * rights."  Use, duplication or disclosure is subject to restrictions as
 * set forth in NASA FAR SUP 18-52.227-79 (April 1985) "Commercial
 * Computer Software-Restricted Rights (April 1985)."  If the Clause at
 * 18-52.227-74 "Rights in Data General" is specified in the contract,
 * then the "Alternate III" clause applies.
 */
#include <rw/tvhdict.h>
#include <rw/cstring.h>
#include <rw/rstream.h>
#include <iomanip.h>

class Count
{                                                               // 1
  int	N;

public:
  Count() : 	N(0) { }                                        // 2
  int	operator++()  { return ++N; }                           // 3
  operator	int() { return N; }                             // 4
};

unsigned hashString ( const RWCString& str )                    // 5
  { return str.hash(); }

main() {

  RWTValHashDictionary<RWCString,Count> map(hashString);	// 6

  RWCString token;

  cout << "Type in a string, "
       << "Enter EOF, CTRL Z (PC's) or CTRL D (UNIX) to quit. "
       << endl << endl << endl;

  while ( cin >> token )                                        // 7
    ++map[token];                                               // 8

  RWTValHashDictionaryIterator<RWCString,Count> next(map);	// 9

  cout << endl << "Word frequencies of your string: " << endl;
  cout.setf(ios::left, ios::adjustfield);                       // 10
  while ( ++next )                                              // 11
    cout << setw(20) << next.key()
         << " " << setw(10) << next.value() << endl;            // 12

  return 0;
}
