/***************************************************************************
 *
 * ep_cntnr.cc - template definitions for RW_PBase<StdColl,RWColl,DataTypes>
 * 
 * $Id: ep_cntnr.cc,v 7.13 1996/03/22 22:03:23 griswolf Exp $
 *
 * (c) Copyright 1989 - 1996 Rogue Wave Software, Inc.
 * ALL RIGHTS RESERVED
 *
 * The software and information contained herein are proprietary to, and
 * comprise valuable trade secrets of, Rogue Wave Software, Inc., which
 * intends to preserve as trade secrets such software and information.
 * This software is furnished pursuant to a written license agreement and
 * may be used, copied, transmitted, and stored only in accordance with
 * the terms of such license and with the inclusion of the above copyright
 * notice.  This software and information or any other copies thereof may
 * not be provided or otherwise made available to any other person.
 *
 * Notwithstanding any other lease or license that may pertain to, or
 * accompany the delivery of, this computer software and information, the
 * rights of the Government regarding its use, reproduction and disclosure
 * are as set forth in Section 52.227-19 of the FARS Computer
 * Software-Restricted Rights clause.
 * 
 * Use, duplication, or disclosure by the Government is subject to
 * restrictions as set forth in subparagraph (c)(1)(ii) of the Rights in
 * Technical Data and Computer Software clause at DFARS 252.227-7013.
 * Contractor/Manufacturer is Rogue Wave Software, Inc.,
 * P.O. Box 2328, Corvallis, Oregon 97339.
 *
 * This computer software and information is distributed with "restricted
 * rights."  Use, duplication or disclosure is subject to restrictions as
 * set forth in NASA FAR SUP 18-52.227-79 (April 1985) "Commercial
 * Computer Software-Restricted Rights (April 1985)."  If the Clause at
 * 18-52.227-74 "Rights in Data General" is specified in the contract,
 * then the "Alternate III" clause applies.
 *
 ****************************************************************************
 * 
 * $Log: ep_cntnr.cc,v $
 * Revision 7.13  1996/03/22 22:03:23  griswolf
 * Scopus #2898: Make things "bool correct".
 *
 * Revision 7.12  1996/02/13 12:14:17  jims
 * Small mods to the interface
 *
 * Revision 7.11  1996/01/30 08:09:18  jims
 * Add definitions for newly out-of-lined functions
 *
 * Revision 7.10  1996/01/24 21:07:41  jims
 * Simplify implementation of otis-stl ptr-based collections
 * by using container<T*> impls instead of container<void*>
 *
 * Revision 7.9  1995/12/18 20:07:38  pearson
 * Borland 4.5 and other compilers do not understand the bool type, change
 * bool to RWBoolean
 *
 * Revision 7.8  1995/12/11 22:30:41  jims
 * Remove 'Sca' from interior class names
 * Add 'rw_' to global helper classes
 * Change 'muterator' to 'filterator'
 *
 * Revision 7.7  1995/11/13 12:45:50  jims
 * Add value_type version of index
 *
 * Revision 7.6  1995/10/27 16:04:01  jims
 * Qualify size_type in npos definition for cset port
 *
 * Revision 7.5  1995/09/05  21:57:10  jims
 * Change tlyrs.h to tlyrs.str
 *
 * Revision 7.4  1995/07/27  22:02:33  jims
 * Add header with file name, short description, $Id and $Log
 * 
 ****************************************************************************/

#define TEMPLATE template <class StdColl, class RWColl>
#define PC       RW_PBase<StdColl,RWColl>

TEMPLATE
void
PC::apply(void (*fn)(PC::value_type,void*),void *x) {
  iterator iter = begin();
  while(iter != end()) {
    (*fn)(*iter,x);
    ++iter;
  }
}

TEMPLATE
void
PC::apply(void (*fn)(PC::reference,void*),void *x) {
  iterator iter = begin();
  while(iter != end()) {
    (*fn)(*iter,x);
    ++iter;
  }
}

TEMPLATE
bool
PC::contains(bool(*fn)(PC::value_type,void*),void* x) const {
  const_iterator iter = begin();
  while(iter != end()) {
    if((*fn)(*iter,x)) break;
    ++iter;
  }
  return iter != end();
}

TEMPLATE
PC::size_type
PC::index(bool (*fn)(PC::value_type, void*), void* x) const
{
  const_iterator i = begin();
  size_type idx = 0;
  for(/**/; i != end(); ++i) {
    if((*fn)(*i,x))
      return idx;
    ++idx;
  }
  return npos;
}


TEMPLATE
PC::size_type
PC::occurrencesOf(bool (*fn)(PC::value_type,void*),void* x) const {
  size_type ret = 0;
  const_iterator iter = begin();
  while(iter != end()) {
    if((*fn)(*iter,x)) ++ret;
    ++iter;
  }
  return ret;
}


TEMPLATE
PC::size_type PC::npos = ~(PC::size_type)0;

#undef TEMPLATE
#undef PC

