/***************************************************************************
 *
 * ep_mcntn.cc - template definitions for RW_PMapCntnr<StdColl,RWColl,Key,T>
 *
 * $Id: ep_mcntn.cc,v 7.11 1996/02/18 01:40:43 griswolf Exp $
 *
 * (c) Copyright 1989 - 1996 Rogue Wave Software, Inc.
 * ALL RIGHTS RESERVED
 *
 * The software and information contained herein are proprietary to, and
 * comprise valuable trade secrets of, Rogue Wave Software, Inc., which
 * intends to preserve as trade secrets such software and information.
 * This software is furnished pursuant to a written license agreement and
 * may be used, copied, transmitted, and stored only in accordance with
 * the terms of such license and with the inclusion of the above copyright
 * notice.  This software and information or any other copies thereof may
 * not be provided or otherwise made available to any other person.
 *
 * Notwithstanding any other lease or license that may pertain to, or
 * accompany the delivery of, this computer software and information, the
 * rights of the Government regarding its use, reproduction and disclosure
 * are as set forth in Section 52.227-19 of the FARS Computer
 * Software-Restricted Rights clause.
 * 
 * Use, duplication, or disclosure by the Government is subject to
 * restrictions as set forth in subparagraph (c)(1)(ii) of the Rights in
 * Technical Data and Computer Software clause at DFARS 252.227-7013.
 * Contractor/Manufacturer is Rogue Wave Software, Inc.,
 * P.O. Box 2328, Corvallis, Oregon 97339.
 *
 * This computer software and information is distributed with "restricted
 * rights."  Use, duplication or disclosure is subject to restrictions as
 * set forth in NASA FAR SUP 18-52.227-79 (April 1985) "Commercial
 * Computer Software-Restricted Rights (April 1985)."  If the Clause at
 * 18-52.227-74 "Rights in Data General" is specified in the contract,
 * then the "Alternate III" clause applies.
 *
 ****************************************************************************
 *
 * $Log: ep_mcntn.cc,v $
 * Revision 7.11  1996/02/18 01:40:43  griswolf
 * Replace tabs with spaces, per Rogue Wave standard.
 *
 * Revision 7.10  1996/01/24 21:07:41  jims
 * Simplify implementation of otis-stl ptr-based collections
 * by using container<T*> impls instead of container<void*>
 *
 * Revision 7.9  1996/01/12 22:06:11  kevinj
 * Simpler External Template Persistence (ETP).
 *
 * Revision 7.8  1995/12/14 18:01:21  jims
 * saveOn, restoreFrom now global instead of member functions
 *
 * Revision 7.7  1995/12/05 23:24:42  griswolf
 * Fix Copyright line typo.
 *
 * Revision 7.6  1995/10/29 00:40:00  jims
 * Avoid "used before set" warning in calls to RWMakeNewPtr
 *
 * Revision 7.5  1995/08/24  00:21:36  kevinj
 * Changed saveOn and restoreFrom to return bool.
 *
 * Revision 7.4  1995/08/16  18:05:02  kevinj
 * Changed RWPersistTable and RWRestoreTable add() to insert().
 *
 * Revision 7.3  1995/08/12  00:23:12  kevinj
 * restoreFrom and saveOn for RWFile.
 *
 * Revision 7.2  1995/08/11  17:03:34  kevinj
 * Template persistence 2.2.
 *
 ****************************************************************************/

#define TEMPLATE template <class StdColl, class RWColl, class Key, class T>
#define PMC      RW_PMapCntnr<StdColl, RWColl, Key, T>

TEMPLATE PMC::value_type
PMC::find(PMC::const_reference key) const
{
    const_iterator iter = begin();
    while(iter != end()) {
      if(deref_equal()(*iter,key)) break;
      ++iter;
    }
    if (iter == end()) return nilValue(); else return *iter;
}

TEMPLATE PMC::value_type
PMC::find(bool (*fn)(PMC::value_type, void*), void* x) const
{
    const_iterator iter = begin();
    while(iter != end()) {
      if((*fn)(*iter,x)) break;
      ++iter;
    }
    if (iter == end()) return nilValue(); else return *iter;
}

TEMPLATE
PMC::size_type
PMC::index(const_reference t) const
{
  const_iterator i = begin();
  size_type idx = 0;
  for(/**/; i != end(); ++i) {
    if(deref_equal()(*i,t))
      return idx;
    ++idx;
  }
  return npos;
}

#undef TEMPLATE
#undef PMC

