/***************************************************************************
 *
 * ev_mcntn.cc - template definitions for RW_VMapCntnr<StdColl,RWColl,Key,T>
 * 
 * $Id: ev_mcntn.cc,v 7.13 1996/02/18 01:41:28 griswolf Exp $
 *
 * (c) Copyright 1989 - 1996 Rogue Wave Software, Inc.
 * ALL RIGHTS RESERVED
 *
 * The software and information contained herein are proprietary to, and
 * comprise valuable trade secrets of, Rogue Wave Software, Inc., which
 * intends to preserve as trade secrets such software and information.
 * This software is furnished pursuant to a written license agreement and
 * may be used, copied, transmitted, and stored only in accordance with
 * the terms of such license and with the inclusion of the above copyright
 * notice.  This software and information or any other copies thereof may
 * not be provided or otherwise made available to any other person.
 *
 * Notwithstanding any other lease or license that may pertain to, or
 * accompany the delivery of, this computer software and information, the
 * rights of the Government regarding its use, reproduction and disclosure
 * are as set forth in Section 52.227-19 of the FARS Computer
 * Software-Restricted Rights clause.
 * 
 * Use, duplication, or disclosure by the Government is subject to
 * restrictions as set forth in subparagraph (c)(1)(ii) of the Rights in
 * Technical Data and Computer Software clause at DFARS 252.227-7013.
 * Contractor/Manufacturer is Rogue Wave Software, Inc.,
 * P.O. Box 2328, Corvallis, Oregon 97339.
 *
 * This computer software and information is distributed with "restricted
 * rights."  Use, duplication or disclosure is subject to restrictions as
 * set forth in NASA FAR SUP 18-52.227-79 (April 1985) "Commercial
 * Computer Software-Restricted Rights (April 1985)."  If the Clause at
 * 18-52.227-74 "Rights in Data General" is specified in the contract,
 * then the "Alternate III" clause applies.
 *
 ****************************************************************************
 *
 * $Log: ev_mcntn.cc,v $
 * Revision 7.13  1996/02/18 01:41:28  griswolf
 * Replace tabs with spaces, per Rogue Wave standard.
 *
 * Revision 7.12  1996/01/12 22:06:11  kevinj
 * Simpler External Template Persistence (ETP).
 *
 * Revision 7.11  1995/12/14 18:01:21  jims
 * saveOn, restoreFrom now global instead of member functions
 *
 * Revision 7.10  1995/10/20 07:04:55  jims
 * Add missing return statement to restoreFromAux
 *
 * Revision 7.9  1995/09/05  21:59:28  jims
 * Change tlyrs.h to tlyrs.str
 *
 * Revision 7.8  1995/08/23  22:42:27  kevinj
 * Changed saveOn and restoreFrom to return bool.
 *
 * Revision 7.7  1995/08/14  05:59:23  jims
 * include rw/rwfile.h and rw/vstream.h
 *
 * Revision 7.6  1995/08/12  00:23:12  kevinj
 * restoreFrom and saveOn for RWFile.
 *
 * Revision 7.5  1995/08/10  23:42:46  kevinj
 * Moved inline functions out of line.
 *
 * Revision 7.5  1995/08/10  23:42:46  kevinj
 * Moved inline functions out of line.
 *
 * Revision 7.4  1995/07/27  22:02:33  jims
 * Add header with file name, short description, $Id and $Log
 *
 ****************************************************************************/

#include "rw/rwfile.h"
#include "rw/vstream.h"

#define TEMPLATE template <class StdColl, class RWColl, class Key, class T>
#define VMC      RW_VMapCntnr<StdColl, RWColl, Key, T>

TEMPLATE bool
VMC::find(bool (*fn)(VMC::const_reference,void*), void* x, pair<Key,T>& val) const
{
  const_iterator i = begin();
  for(/**/ ; i != end(); ++i)
    if((*fn)(*i,x))
      break;
  if(i != end()) {
    val.first = (*i).first;
    val.second =(*i).second;
    return true;
  }
  return false;
}

TEMPLATE bool
VMC::find(const_reference key, pair<Key,T>& val) const
{
  const_iterator i = begin();
  for(/**/ ; i != end(); ++i)
    if(*i == key)
      break;
  if(i != end()) {
    val.first = (*i).first;
    val.second =(*i).second;
    return true;
  }
  return false;
}

#undef TEMPLATE
#undef VMC
