#pragma ident "@(#)note.h 1.6 95/04/19"

/*
 * Copyright 04/19/95 Sun Microsystems, Inc. All Rights Reserved
 */

/*
 * _NOTE() interface for annotating source with info for enhanced lint.
 *
 * This is the underlying interface; NOTE (alint/src/include//note.h) is the
 * preferred interface, but all exported header files should include this
 * file directly and use _NOTE so as not to take "NOTE" from the user's
 * namespace.  For consistency, *all* kernel source should use _NOTE.
 *
 * By default, annotations expand to nothing.  This file is the
 * interposed version which expands annotations for enchanced lint.
 *
 */
 
#ifndef _SYS_NOTE_H
#define _SYS_NOTE_H

#define NOTE		_NOTE		/* from note.h for unify */

#define _NOTE(note)	___note(__NOTE__ ## note)___note

#define __NOTE__ALIGNMENT		"ALIGNMENT"
#define __NOTE__ARGSUSED		"ARGSUSED"
#define __NOTE__ARGUNUSED		"ARGUNUSED"
#define __NOTE__CONSTCOND		"CONSTCOND"
#define __NOTE__CONSTANTCONDITION	"CONSTANTCONDITION"
#define __NOTE__EMPTY			"EMPTY"
#define __NOTE__FALLTHRU		"FALLTHRU"
#define __NOTE__FALLTHROUGH		"FALLTHROUGH"
#define __NOTE__LINTLIBRARY		"LINTLIBRARY"
#define __NOTE__LINTED			"LINTED"
#define __NOTE__NOTREACHED		"NOTREACHED"
#define __NOTE__PRINTFLIKE		"PRINTFLIKE"
#define __NOTE__PROTOLIB		"PROTOLIB"
#define __NOTE__SCANFLIKE		"SCANFLIKE"
#define __NOTE__VARARGS			"VARARGS"
#define __NOTE__FUNCKIND		"FUNCKIND"

#endif  /* _SYS_NOTE_H */
