/* *************************************************************************
 *  Copyright (C) 1990-1993 by ILOG.
 *  All Rights Reserved.
 *
 *  N O T I C E
 *
 *  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
 *  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
 * *************************************************************************/

/*
 *  File :        IlogViews.h
 *  Description : Header of the IlogViews widgets.
 *    Declares:
 *       IlvManagerWidgetClass
 *       IlvCellManagerWidgetClass
 */

#ifndef _IlogViewsWdg_h
#define _IlogViewsWdg_h

/* 
 * Class record constants
 */
externalref WidgetClass  xmIlvManagerWidgetClass;
externalref WidgetClass  xmIlvCellManagerWidgetClass;

typedef struct _XmIlvManagerClassRec *XmIlvManagerWidgetClass;
typedef struct _XmIlvManagerRec      *XmIlvManagerWidget;
typedef struct _XmIlvCellManagerClassRec *XmIlvCellManagerWidgetClass;
typedef struct _XmIlvCellManagerRec      *XmIlvCellManagerWidget;

/*
 * Define resource strings for the IlogViews widgets
 */
#define XtNilvManager "ilvManager"
#define XmNilvManager XtNilvManager
#define XtCilvManager "IlvManager"

#define XtNilvManagerId "ilvManagerId"
#define XmNilvManagerId XtNilvManagerId
#define XtCilvManagerId "IlvManagerId"

#define XtNilvSelectInt "ilvSelectInt"
#define XmNilvSelectInt XtNilvSelectInt
#define XtCilvSelectInt "IlvSelectInt"

#define XtNilvFileName "ilvFileName"
#define XmNilvFileName XtNilvFileName
#define XtCilvFileName "IlvFileName"

#define XtNilvView "ilvView"
#define XmNilvView XtNilvView
#define XtCilvView "IlvView"

#define XtNilvHorizontalScrollBar "ilvHorizontalScrollBar"
#define XmNilvHorizontalScrollBar XtNilvHorizontalScrollBar
#define XtCilvHorizontalScrollBar "IlvHorizontalScrollBar"

#define XtNilvVerticalScrollBar "ilvVerticalScrollBar"
#define XmNilvVerticalScrollBar XtNilvVerticalScrollBar
#define XtCilvVerticalScrollBar "IlvVerticalScrollBar"

#define XtNilvCellManager "ilvCellManager"
#define XmNilvCellManager XtNilvCellManager
#define XtCilvCellManager "IlvCellManager"

#define XtNilvNbRow "ilvNbRow"
#define XmNilvNbRow XtNilvNbRow
#define XtCilvNbRow "IlvNbRow"

#define XtNilvNbCol "ilvNbCol"
#define XmNilvNbCol XtNilvNbCol
#define XtCilvNbCol "IlvNbCol"

/*
 * Convenience's functions
 */
#if defined(__cplusplus)
extern "C" {
#endif
XtPointer XmGetIlvDisplay(
#if !defined(_NO_PROTO)
			  Widget viewsWidget
#endif
			  );
Widget    XmCreateIlvManager(
#if !defined(_NO_PROTO)
			     Widget p, String name, ArgList args, Cardinal n
#endif
			     );
Widget    XmCreateIlvCellManager(
#if !defined(_NO_PROTO)
				 Widget p, String name,
				 ArgList args, Cardinal n
#endif
				 );
XtPointer XmGetIlvManager(
#if !defined(_NO_PROTO)
			  Widget viewsWidget
#endif
			  );
XtPointer XmGetIlvCellManager(
#if !defined(_NO_PROTO)
			      Widget viewsWidget
#endif
			      );
XtPointer XmGetIlvManagerView(
#if !defined(_NO_PROTO)
			      Widget viewsWidget
#endif
			      );
XtPointer XmGetIlvCellManagerView(
#if !defined(_NO_PROTO)
				  Widget viewsWidget
#endif
				  );
#if defined(__cplusplus)
};
#endif

#endif
