;;; cyrillic-hooks.el --- pre-loaded support for Cyrillic.

;; Copyright (C) 1992,93,94,95 Free Software Foundation, Inc.
;; Copyright (C) 1995 Amdahl Corporation.
;; Copyright (C) 1995 Sun Microsystems.

;; This file is part of XEmacs.

;; XEmacs is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; XEmacs is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;; General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with XEmacs; see the file COPYING.  If not, write to the Free
;; Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

;;; Synched up with: Mule 2.3.

;; For syntax of Cyrillic
(let ((c 33))
  (while (< c 128)
    (modify-syntax-entry (make-char 'cyrillic c) "w")
    (setq c (1+ c))))
(modify-syntax-entry (make-char 'cyrillic 32) "w") ; no-break space
(modify-syntax-entry ?,L-(B ".")
(modify-syntax-entry ?,Lp(B ".")
(modify-syntax-entry ?,L}(B ".")



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; CYRILLIC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(make-coding-system
 'iso-8859-5 'iso2022
 "MIME ISO-8859-5"
 '(charset-g0 ascii
   charset-g1 cyrillic
   charset-g2 t
   charset-g3 t
   mnemonic "ISO8/Cyr"
   ))

(add-hook 'quail-package-alist '("jcuken" "quail/cyrillic"))
(add-hook 'quail-package-alist '("macedonian" "quail/cyrillic"))
(add-hook 'quail-package-alist '("serbian" "quail/cyrillic"))
(add-hook 'quail-package-alist '("beylorussian" "quail/cyrillic"))
(add-hook 'quail-package-alist '("ukrainian" "quail/cyrillic"))
(add-hook 'quail-package-alist '("yawerty" "quail/cyrillic"))

(define-language-environment 'cyrillic
  "Cyrillic"
  #'(lambda ()
      (set-coding-category-system 'iso-8-designate 'iso-8859-5)
      (set-coding-priority-list '(iso-8-designate iso-8-1))
      (set-default-file-coding-system 'iso-8859-5)
      (setq display-coding-system 'iso-8859-5)
      (setq keyboard-coding-system 'iso-8859-5)
      (setq-default quail-current-package
		    (assoc "yawerty" quail-package-alist))))
