;;; mule-load.el --- Load up all pre-loaded Mule Lisp files.
;; Copyright (C) 1995 Sun Microsystems.

;; This file is part of XEmacs.

;; XEmacs is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; XEmacs is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;; General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with XEmacs; see the file COPYING.  If not, write to the Free
;; Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

;; (load-gc) is defined in loadup.el

;; Load these two first, to set up the most basic stuff.
(load-gc "mule-charset")
(load-gc "mule-coding")
;; Load this next so that file I/O of files with extended characters
;; is handled well.
(load-gc "mule-files")
;; Load the remaining basic files.
(load-gc "mule-category")
;;(load-gc "mule-process")
(load-gc "mule-ccl")
(load-gc "mule-misc")
(when (featurep 'x)
  (load-gc "mule-x-init"))

;; Now load files to set up all the different languages/environments
;; that Mule knows about.

(load-gc "arabic-hooks")
(load-gc "chinese-hooks")
(load-gc "cyrillic-hooks")
(load-gc "ethiopic-hooks")
(load-gc "european-hooks")
(load-gc "greek-hooks")
(load-gc "hebrew-hooks")
(load-gc "ipa-hooks")
(load-gc "japanese-hooks")
(load-gc "korean-hooks")
(load-gc "thai-hooks")
(load-gc "vietnamese-hooks-1")
(load-gc "vietnamese-hooks-2")

;; load this last.  It sets up the XEmacs environment for Mule,
;; and assumes the existence of various stuff above.
(load-gc "mule-init")

