.TH mkclassproto N "09 Mar 1994"
.SH NAME
mkclassproto \- build a proto area for class action script testing
.SH SYNOPSIS
.B mkclassproto
.BI \-n newproto
.BI \-s srcproto
.BI \-p pkgdir
.BI \-a arch
[
.B \-v
]
.SH DESCRIPTION
.LP
mkclassproto builds a sparsely populated proto area for use with the chkclasses
test script.  The new proto area will only contain the files found in the
editable classes.  The proto area may be used for either a base or
compare directory structure.
.LP
A list of files in the editable classes is built from the package definition
tree and architecture specified with the
.B "-p"
and
.B "-a"
options.
These files are copied from the source proto and installed in the new proto
under the same path.  All necessary directories are created.
.LP
If the source and destination paths in the prototype file differ, the
source path is used.
.SH OPTIONS
.TP 10
.BI \-n newproto
Root path of the proto area to be created.
.TP 10
.BI \-s srcproto
Root directory of the source proto area.
.TP 10
.BI \-p pkgdir
Root directory of the package definition tree.
.TP 10
.BI \-a arch
Specify the architecture.  Different platforms of the same architecture are
translated to the base architecture.  Thus sun4, sun4c, sun4m, etc. are
translated to sparc.
.TP 10
.B \-v
Verbose.  Show the directories created and the files copied.
.SH SEE ALSO
chkclasses(N), chkclassproto(N), syncprotos(N)
.SH CAVEATS
.LP
In the ON consolidation, several of the files contained within the
editable classes are installed in the proto build area with restricted
read permissions.
.B mkclassproto
should be run as root to avoid any permission denied problems.
To avoid similar problems when running
.B chkclasses
, files are given group and world read permission when they are copied.
