.TH syncprotos N "09 Mar 1994"
.SH NAME
syncprotos \- Synchronize a group of proto trees.
.SH SYNOPSIS
syncprotos 
.BI \-P proto,proto[,...]
.BI \-p pkgdir
.BI \-a arch
.SH DESCRIPTION
.B syncprotos
synchronizes a group of proto trees so they all have the same set of
files.  It propagates back new files which were either introduced in
a later release or from an added class.  
A list of files in the editable classes is built from the package definition
tree and architecture specified with the
.B "-p"
and
.B "-a"
options.
The
.B "-P"
lists the root directories of the proto areas to be synchronized.
Ordering is important.  The list is assumed to be ordered from oldest
to newest release.
For each file,
.BR syncprotos ,
starts searching in the oldest release.  If the file is not, found it
moves forward in the list of proto areas, until it is.  The file is then
copied back to all the protos which did no have it.  Errors are reported
for files which are not found in any of the proto trees.
.SH OPTIONS
.TP 10
.BI \-P proto
A comma separated list of root directories of proto areas to synchronize.
The list needs to be ordered from oldest to newest release.
.TP 10
.BI \-p pkgdir
Root directory of the package definition tree.
.TP 10
.BI \-a arch
Specify the architecture.  Different platforms of the same architecture are
translated to the base architecture.  Thus sun4, sun4c, sun4m, etc. are
translated to sparc.
.SH EXAMPLE
.LP
Assume you wish to synchronize proto areas for the ON release 5.1, 5.2,
and 5.3.  The proto trees for the sparc architecture on in
/net/dunk/dunk/chkclasses_proto/sparc under the release name and the package
definitions are in
/ws/train/usr/src/pkgdefs:
.sp
.ti 10
.nf
.na
cd /net/dunk/dunk/chkclasses_proto/sparc
.ti 10
syncprotos -P5.1,5.2,5.3 -p/ws/train/usr/src/pkgdefs -asparc
.SH SEE ALSO
.LP
chkclasses(N), mkclassproto(N), chkclassproto(N)
.SH CAVEATS
.LP
The comma separated list of proto directories for the
.B "-P"
option must be passed as a single argument.  Therefore, there can be
no spaces between the commas or the entire list needs to be quoted.
